var map;

function initializeMap() {
	if (GBrowserIsCompatible()) {
		map = new GMap2(document.getElementById("map_canvas"));
		map.addControl(new GMapTypeControl());
		map.addControl(new GLargeMapControl());
		map.addControl(new GScaleControl());
		map.setCenter(new GLatLng(0, 0), 0);
	}
}

function searchBandConcerts() {
	var httpRequest = createXMLHttpRequest();
	var bandName = $('#bandName').val();
	$('#loading').text('Searching...');
	var url = 'ControllerServlet?action=SearchBandConcerts&bandName=' + bandName;
    httpRequest.open('GET', url, true);
    httpRequest.onreadystatechange = function(){
       if( this.readyState == 4 && this.status == 200 ){
           /* Recebe um JSON */
           updateMap(this);
       }
    };
    httpRequest.send(null);
    
}

function updateMap(xmlHttpRequest) {
	map.clearOverlays();
	var shows = eval('('+ xmlHttpRequest.responseText +')');
	
	if (shows.show == undefined) {
		$('#loading').text('Not found');
		map.setCenter(new GLatLng(0, 0), 0);
		return;
	} else {
		$('#loading').text('');
	}
	
	var bounds = new GLatLngBounds();
	var bandName = shows.band;
    for (i = 0; i < shows.show.length; i++) {
    	var marker = createMarker(bandName, shows.show[i]);
    	bounds.extend(new GLatLng(shows.show[i].lat, shows.show[i].lng));
    	map.addOverlay(marker);
    }
    map.setZoom(map.getBoundsZoomLevel(bounds));
    map.setCenter(bounds.getCenter());
    
}

function createMarker(band, show) {
	var lat = show.lat;
	var lng = show.lng;
	var city = show.city;
	var state = show.state;
	var bandName = capitalizeString(band);
	var place = show.place;
	var date = show.date;

	var marker = new GMarker(new GLatLng(lat, lng));
	GEvent.addListener(marker, "click", function() {
		var myHtml = "<h3><u>" + bandName + " Concert</u></h3>";
		myHtml = myHtml + "At " + place + ", " + city + ", " + state
				+ "<br/><br/>";
		myHtml = myHtml + "<b>Date: </b>" + date;
		marker.openInfoWindowHtml(myHtml);
	});

	return marker;
}

function createXMLHttpRequest() {
    try { return new ActiveXObject("Msxml2.XMLHTTP");    } catch(e) {}
    try { return new ActiveXObject("Microsoft.XMLHTTP"); } catch(e) {}
    try { return new XMLHttpRequest();                   } catch(e) {}
    alert("XMLHttpRequest not supported");
    return null;
}

function capitalizeString(str) {
    var newStr = '';
    var strList = str.split(' ');
    for(var i = 0; i < strList.length; i++) {
            newStr += strList[i].substring(0,1).toUpperCase() + strList[i].substring(1, strList[i].length) + ' ';
    }
    return newStr;
}

